package simulator.utils.workload;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.impl.LogFactoryImpl;

import simulator.workload.reader.archive.swf.SWFFields;

public class IncorrectTaskRemover implements TaskManagerInterface{

	public static Log log = LogFactoryImpl.getLog(IncorrectTaskRemover.class);
	
	public String[] manageTask(String[] task) {
		if(task == null)
			return null;
		
		if("-1".equals(task[SWFFields.DATA_RUN_TIME])) {
			log.info("Removing task "+task[SWFFields.DATA_JOB_NUMBER] + ",  RUN_TIME = -1");
			return null;	
		}
		if("-1".equals(task[SWFFields.DATA_REQUESTED_TIME])) {
			log.info("Removing task "+task[SWFFields.DATA_JOB_NUMBER] + ",  REQUESTED_TIME = -1");
			return null;
		}
		if("-1".equals(task[SWFFields.DATA_NUMBER_OF_ALLOCATED_PROCESSORS])){
			log.info("Removing task "+task[SWFFields.DATA_JOB_NUMBER] + ",  NUMBER_OF_ALLOCATED_PROCESSORS = -1");
			return null;
		}
		if("-1".equals(task[SWFFields.DATA_REQUESTED_NUMBER_OF_PROCESSORS])){
			log.info("Removing task "+task[SWFFields.DATA_JOB_NUMBER] + ",  REQUESTED_NUMBER_OF_PROCESSORS = -1");
			return null;
		}
		
		return task;
	}

}
