<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="2.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/">
		<!-- Copy everything about each DEBB into a separate file -->
		<xsl:for-each select="//*[ComponentId]">

			<xsl:variable name="oldComponentId">
				<xsl:value-of select="ComponentId" />
			</xsl:variable>
			<!-- Remove slash from debb component id, as it causes problems -->
			<xsl:variable name="newComponentId">
				<xsl:value-of select="translate($oldComponentId, '/', '_')" />
			</xsl:variable>
			<xsl:value-of select="$newComponentId" />
			
			<xsl:result-document method="xml"
				href="xml/debb_component_{$newComponentId}.xml" >
				<xsl:copy-of select="." />
			</xsl:result-document>
		</xsl:for-each>
	</xsl:template>
</xsl:stylesheet>